/**
 * Add an action button to reply to a message.
 * TODO: Add settings to handle this plugin
 */
converse.plugins.add('sib-reply-to-message', {
  initialize() {
    const _converse = this._converse;
    const { api, __ } = _converse;
    const { utils } = converse.env;

    api.listen.on('getMessageActionButtons', (el, buttons) => {

      // Do not add if the message is not from a MUC
      // Do not add if the message is from the current user
      if (el.model.get('type') !== 'groupchat' || el.model.get('sender') === 'me') {
        return buttons;
      }

      buttons.push({
        'i18n_text': __('Reply'),
        'handler': ev => {
          const chat_textarea = utils.ancestor(el, '.chatbox')?.querySelector('.chat-textarea');
          chat_textarea.value = `@${el.model.get('nick')} `;
          chat_textarea.focus();
        },
        'button_class': 'chat-msg__action-reply',
        'icon_class': 'fa fa-reply',
        'name': 'reply',
      });

      return buttons;
    });
  },
});
